/* -*- Mode: c++; -*- */
/*  --------------------------------------------------------------------
 *  Filename:
 *    src/mailbox/maildir-expunge.cc
 *  
 *  Description:
 *    Implementation of the Maildir class.
 *
 *  Authors:
 *    Andreas Aardal Hanssen <bincimap@andreas.hanssen.name>
 *
 *  Bugs:
 *
 *  ChangeLog:
 *
 *  --------------------------------------------------------------------
 *  Copyright 2002, 2003 Andreas Aardal Hanssen
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *  --------------------------------------------------------------------
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "maildir.h"

using namespace ::std;

//------------------------------------------------------------------------
void Binc::Maildir::imapExpunge(void)
{
  if (readonly) return;

  iterator i = begin(all, INCLUDE_EXPUNGED);
  iterator e = end();
  while (i != e) {
    Message & message = *i;
    if ((message.getStdFlags() & Message::F_DELETED) != 0) {
      message.setExpunged();

      const string &fname = i.fixedFilename();
      if (fixedtofile.find(fname) != fixedtofile.end()) {
	while (unlink((path + "/cur/" + fixedtofile[fname]).c_str()) != 0) {
	  scanFileNames();
	  if (fixedtofile.find(fname) == fixedtofile.end())
	    break;
	}
      }
    }
    ++i;
  }
}
